// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program uses the Control Word through a PDO to enable the AKD drive.

//set hartbeat. It is not being used in this program, but could be as follows.
//Send 601h  8  2bh 17h 10h 00h F4h 01h 00h 00h // Switch on heart beat

//Disable TxPDO's
//Send 601h  8  23h 00h 18h 01h 81h 01h 00h 80h // TPDO1 - set bit 31 to disable PDO
//Wait 20
Send 601h  8  23h 01h 18h 01h 81h 02h 00h 80h // TPDO2 - set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 02h 18h 01h 81h 03h 00h 80h // TPDO3 - set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 03h 18h 01h 81h 04h 00h 80h // TPDO4 - set bit 31 to disable PDO
Wait 20

//TPDO1	Mapping
//Send 601h  8  2Fh 00h 1Ah 00h 00h 00h 00h 00h // delete TPDO1 mapping
//Wait 20
//Send 601h  8  23h 00h 1Ah 01h 10h 00h 41h 60h // TPDO1 entry 1: status word
//Wait 20
//Send 601h  8  2Fh 00h 1Ah 00h 01h 00h 00h 00h // TPDO1 - 1 mapped object
//Wait 20

//TPDO - Address and Enable
Send 601h  8  23h 00h 18h 01h 81h 01h 00h 00h // TPDO1 - COB-ID 181
Wait 20
//Send 601h  8  23h 01h 18h 01h 00h 00h 00h 00h // TPDO2 - Off
//Wait 20
//Send 601h  8  23h 02h 18h 01h 00h 00h 00h 00h // TPDO3 - Off
//Wait 20
//Send 601h  8  23h 03h 18h 01h 00h 00h 00h 00h // TPDO4 - Off
//Wait 20

//Disable RPDO's
//Send 601h  8  23h 00h 14h 01h 01h 02h 00h 80h // RPDO1 set bit 31 to disable PDO
//Wait 20
Send 601h  8  23h 01h 14h 01h 01h 03h 00h 80h // RPDO2 set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 02h 14h 01h 01h 04h 00h 80h // RPDO3 set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 03h 14h 01h 01h 05h 00h 80h // RPDO4 set bit 31 to disable PDO
Wait 20

//RPDO1
//Send 601h  8  23h 00h 14h 01h 01h 02h 00h 00h // RPDO1 set to drive address 1 (COB-ID 201)
//Wait 20
//Send 601h  8  2Fh 00h 16h 00h 00h 00h 00h 00h // delete RPDO1 mapping
//Wait 20
//Send 601h  8  23h 00h 16h 01h 10h 00h 40h 60h // RPDO1 entry 1 map: Control Word
//Wait 20
//Send 601h  8  2Fh 00h 16h 00h 01h 00h 00h 00h // One RPDO1 mapped object
//Wait 20

//Send 601h  8  23h 01h 14h 01h 00h 00h 00h 00h // (Turn off RPDO2)
//Wait 20
//Send 601h  8  23h 02h 14h 01h 00h 00h 00h 00h // (Turn off RPDO3)
//Wait 20
//Send 601h  8  23h 03h 14h 01h 00h 00h 00h 00h // (Turn off RPDO4)
//Wait 20

//RPDO - Address and Enable
//Send 601h  8  23h 01h 14h 01h 00h 00h 00h 00h // RPDO2 Off
//Wait 20
//Send 601h  8  23h 02h 14h 01h 00h 00h 00h 00h // RPDO3 Off
//Wait 20
//Send 601h  8  23h 03h 14h 01h 00h 00h 00h 00h // RPDO4 Off
//Wait 20

//TPDO transmit type
Send 601h  8  23h 00h 18h 02h FFh 00h 00h 00h // TPDO1 transmit on event
Wait 20

//RPDO transmit type
Send 601h  8  2Fh 00h 14h 02h FFh 00h 00h 00h // RPDO1 transmit on event
Wait 20

Send 000h  2  01h 01h // NMT: start PDO's
Wait 10

Here:

Send 201h  2  80h 00h // RPDO1 Control Word bit 7 ON (Fault Reset)
Wait 10

Send 201h  2  06h 00h // RPDO1 Control Word bits 1,2 ON (Disable)
Wait 10

Send 201h  2  07h 00h // RPDO1 Control Word bits 0,1,2 ON (Enable)
Wait 10

Send 201h  2  0Fh 00h // RPDO1 Control Word bits 0,1,2,3 ON (Operation Enable)
Wait 10

Enabled:
Wait 100
Send 601h  8 40h 02h 10h 00h 00h 00h 00h 00h // manufacturer specific status
Wait 10
Waitdata 12 581h 8 43h 02h 10h 00h 00h 40h 00h 20h //wait for status bits 29 and 14 (hardware enabled)
	if false
	goto Enabled

Disabled:
Wait 100
Send 601h  8 40h 02h 10h 00h 00h 00h 00h 00h // manufacturer specific status
Wait 10
Waitdata 12 581h 8 43h 02h 10h 00h 00h 00h 00h 00h //wait for status bits 29 and 14 off (hardware disabled)
	if false
	goto Disabled

GOTO Here

Stop:
