// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program sets the AKD drive to Profile Position Mode, commands target positions,
//and executes relative moves with time delays between.
//Configure the AKD drive to run motion tasks in position mode. Save to eeprom and do a power cycle. Then run this program.

//TPDO transmit type
//Send 601h  8  23h 00h 18h 02h FFh 00h 00h 00h // TPDO1 transmit on event
//Wait 20
//Send 601h  8  23h 01h 18h 02h FFh 00h 00h 00h // TPDO2 transmit on event
//Wait 20

//Set up PGEARI and PGEARO
//Send 601h  8  23h 93h 60h 01h 00h 00h 10h 00h // PGEARO = 20 bit
//Wait 20
//Send 601h 8 40h 93h 60h 01h 00h 00h 00h 00h // 
//Wait 20

//Send 601h  8  23h 93h 60h 02h 10h 27h 00h 00h // PGEARI = 10000 units
//Wait 20
//Send 601h 8 40h 93h 60h 02h 00h 00h 00h 00h // 
//Wait 20

// ready to switch on	
Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 07h 00h 00h 00h // Control Word: switched on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enable
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

//**** Setup move ****

Send 601h  8  2Fh 60h 60h 00h 01h 00h 00h 00h // switch to profile position mode (DS402 Mode 01)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 83h 60h 00h 32h 00h 00h 00h // acceleration command
Wait 20
Send 601h 8 40h 83h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 84h 60h 00h 32h 00h 00h 00h // deceleration command
Wait 20
Send 601h 8 40h 84h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  2Bh 86h 60h 00h 00h 00h 00h 00h // motion profile type - Linear (trapezoidal)
Wait 20
Send 601h 8 40h 86h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  2bh 40h 60h 00h 4fh 00h 00h 00h // operation enabled, relative move (Bit 6 = 1)
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20



Send 000h  2  01h 01h // NMT: start PDO's
Wait 100

//Enter Target Position Setpoint
Send 401h  8  4Fh 00h E8h 03h 00h 00h 00h 00h // RPDO3 target position
Wait 20
Send 501h  8  4Fh 00h 64h 00h 00h 00h 00h 00h // RPDO4 Profile Velocity setpoint
Wait 20

//Send 601h  8  23h 7Ah 60h 00h E8h 03h 00h 00h // set target position with SDO
//Wait 20
Send 601h  8  40h 7Ah 60h 00h 00h 00h 00h 00h // read target position
Wait 20
Send 601h  8  40h 81h 60h 00h 00h 00h 00h 00h // read Profile Velocity setpoint
Wait 20

Wait 1000

JumpToHere:

Send 201h  2  5Fh 00h // RPDO1 Control Word bit 4 ON (start new move)
Wait 20

Send 201h  2  4Fh 00h // RPDO1 Control Word bit 4 OFF (reset bit 4)
Wait 10

Inposition:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 06h 00h 00h //wait for status word bit 10 (Target Reached)
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 16h 00h 00h
			if false
			//if true
				//goto Stop
			//Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 02h 00h 00h
				//if true
					//goto Stop
		goto Inposition
	
wait 1000

GoTo JumpToHere
Stop:
