// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program sets the AKD drive to Profile Position Mode, commands target positions,
//and executes relative moves with time delays between.
//Configure the AKD drive to run motion tasks in position mode. Save to eeprom and do a power cycle. Then run this program.


//set hartbeat. It is not being used in this program, but could be as follows.
//Send 601h  8  2bh 17h 10h 00h F4h 01h 00h 00h // Switch on heart beat

//Disable TxPDO's
Send 601h  8  23h 00h 18h 01h 81h 01h 00h 80h // TPDO1 - set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 01h 18h 01h 81h 02h 00h 80h // TPDO2 - set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 02h 18h 01h 81h 03h 00h 80h // TPDO3 - set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 03h 18h 01h 81h 04h 00h 80h // TPDO4 - set bit 31 to disable PDO
Wait 20

//TPDO1	Mapping
//Send 601h  8  2Fh 00h 1Ah 00h 00h 00h 00h 00h // delete TPDO1 mapping
//Wait 20
//Send 601h  8  23h 00h 1Ah 01h 10h 00h 41h 60h // TPDO1 entry 1: status word
//Wait 20
//Send 601h  8  2Fh 00h 1Ah 00h 01h 00h 00h 00h // TPDO1 - 1 mapped object
//Wait 20

//TPDO2 Mapping
//Send 601h  8  2Fh 01h 1Ah 00h 00h 00h 00h 00h // delete TPDO2 mapping
//Wait 20
//Send 601h  8  23h 01h 1Ah 01h 20h 00h 64h 60h // TPDO2 entry 1: position actual value
//Wait 20
//Send 601h  8  23h 01h 1Ah 02h 20h 00h 6Ch 60h // TPDO2 entry 2: velocity actual value
//Wait 20
//Send 601h  8  2Fh 01h 1Ah 00h 02h 00h 00h 00h // TPDO2 - 2 mapped objects
//Wait 20

//TPDO - Address and Enable
//Send 601h  8  23h 00h 18h 01h 81h 01h 00h 00h // TPDO1 - COB-ID 181
//Wait 20
//Send 601h  8  23h 01h 18h 01h 81h 02h 00h 00h // TPDO2 - COB-ID 281
//Wait 20

//Disable RPDO's
Send 601h  8  23h 00h 14h 01h 01h 02h 00h 80h // RPDO1 set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 01h 14h 01h 01h 03h 00h 80h // RPDO2 set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 02h 14h 01h 01h 04h 00h 80h // RPDO3 set bit 31 to disable PDO
Wait 20
Send 601h  8  23h 03h 14h 01h 01h 05h 00h 80h // RPDO4 set bit 31 to disable PDO
Wait 20

//RPDO1
Send 601h  8  23h 00h 14h 01h 01h 02h 00h 00h // RPDO1 set to drive address 1 (COB-ID 201)
Wait 20
Send 601h  8  2Fh 00h 16h 00h 00h 00h 00h 00h // delete RPDO1 mapping
Wait 20
Send 601h  8  2Fh 00h 16h 00h 01h 00h 00h 00h // One RPDO2 mapped object
Wait 20
Send 601h  8  23h 00h 16h 01h 10h 00h 40h 60h // RPDO1 entry 1 map: Control Word
Wait 20

//RPDO2
Send 601h  8  23h 01h 14h 01h 01h 03h 00h 00h // RPDO2 set to drive address 1 (COB-ID 301)
Wait 20
Send 601h  8  2Fh 01h 16h 00h 00h 00h 00h 00h // delete RPDO2 mapping
Wait 20
Send 601h  8  2Fh 01h 16h 00h 01h 00h 00h 00h // One RPDO2 mapped object
Wait 20
Send 601h  8  23h 01h 16h 01h 20h 00h 7Ah 60h // RPDO2 entry 1 map: target position
Wait 20

//RPDO3
Send 601h  8  23h 02h 14h 01h 01h 04h 00h 00h // RPDO3 set to drive address 1 (COB-ID 401)
Wait 20
Send 601h  8  2Fh 02h 16h 00h 00h 00h 00h 00h // delete RPDO3 mapping
Wait 20
Send 601h  8  2Fh 02h 16h 00h 01h 00h 00h 00h // One RPDO3 mapped object
Wait 20
Send 601h  8  23h 02h 16h 01h 20h 00h 81h 60h // RPDO3 entry 1 map: profile velocity
Wait 20

//RPDO4
Send 601h  8  23h 03h 14h 01h 00h 00h 00h 00h // (Turn off RPDO4)
Wait 20

//RPDO - Address and Enable
//Send 601h  8  23h 00h 14h 01h 01h 02h 00h 00h // RPDO1 set to drive address 1 (COB-ID 201)
//Wait 20
//Send 601h  8  23h 01h 14h 01h 01h 03h 00h 00h // RPDO2 set to drive address 1 (COB-ID 301)
//Wait 20
//Send 601h  8  23h 02h 14h 01h 01h 04h 00h 00h // RPDO3 set to drive address 1 (COB-ID 401)
//Wait 20

//TPDO transmit type
//Send 601h  8  23h 00h 18h 02h FFh 00h 00h 00h // TPDO1 transmit on event
//Wait 20
//Send 601h  8  23h 01h 18h 02h FFh 00h 00h 00h // TPDO2 transmit on event
//Wait 20


//Set up PGEARI and PGEARO
//Send 601h  8  23h 93h 60h 01h 00h 00h 10h 00h // PGEARO = 20 bit
//Wait 20
//Send 601h 8 40h 93h 60h 01h 00h 00h 00h 00h // 
//Wait 20

//Send 601h  8  23h 93h 60h 02h 10h 27h 00h 00h // PGEARI = 10000 units
//Wait 20
//Send 601h 8 40h 93h 60h 02h 00h 00h 00h 00h // 
//Wait 20

// ready to switch on	
Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 07h 00h 00h 00h // Control Word: switched on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enable
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

//***** Home Mode *****
//Send 601h  8  2fh 60h 60h 00h 06h 00h 00h 00h // switch to homing mode (DS402 Mode 06)
//Wait 20
//Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h // status word
//Wait 20

//Send 601h  8  2fh 98h 60h 00h 23h 00h 00h 00h // homing mode: set homing type - NREF=0
//Wait 20
//Send 601h 8 40h 98h 60h 00h 00h 00h 00h 00h // status word
//Wait 20

//Send 601h  8  2bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word: start homing (Bit 4)
//Wait 20
//Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
//Wait 20

//Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: stop homing (after finished)
//Wait 20

//Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on (disable)
//Wait 20


//**** Setup move ****

Send 601h  8  2Fh 60h 60h 00h 01h 00h 00h 00h // switch to profile position mode (DS402 Mode 01)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 83h 60h 00h 32h 00h 00h 00h // acceleration command
Wait 20
Send 601h 8 40h 83h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 84h 60h 00h 32h 00h 00h 00h // deceleration command
Wait 20
Send 601h 8 40h 84h 60h 00h 00h 00h 00h 00h
Wait 20

//Send 601h  8  23h 81h 60h 00h 64h 00h 00h 00h // Profile Velocity setpoint (velocity command for position move) 100 rpm
//Wait 20
//Send 601h 8 40h 81h 60h 00h 00h 00h 00h 00h
//Wait 20

//Send 601h  8  23h 94h 60h 01h 00h 00h 10h 00h // Velocity encoder factor - numerator
//Wait 20
//Send 601h 8 40h 94h 60h 01h 00h 00h 00h 00h
//Wait 20

//Send 601h  8  23h 94h 60h 02h 01h 00h 00h 00h // Velocity encoder factor - denominator
//Wait 20
//Send 601h 8 40h 94h 60h 02h 00h 00h 00h 00h
//Wait 20

Send 601h  8  2Bh 86h 60h 00h 00h 00h 00h 00h // motion profile type - Linear (trapezoidal)
Wait 20
Send 601h 8 40h 86h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  2bh 40h 60h 00h 4fh 00h 00h 00h // operation enabled, relative move (Bit 6 = 1)
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20



Send 000h  2  01h 01h // NMT: start PDO's
Wait 100

//Enter Target Position Setpoint
Send 301h  8  E8h 03h 00h 00h 00h 00h 00h 00h // RPDO2 target position
Wait 20
Send 401h  4  64h 00h 00h 00h //00h 00h 00h 00h // RPDO3 Profile Velocity setpoint
Wait 20

//Send 601h  8  23h 7Ah 60h 00h E8h 03h 00h 00h // set target position with SDO
//Wait 20
Send 601h  8  40h 7Ah 60h 00h 00h 00h 00h 00h // read target position
Wait 20
Send 601h  8  40h 81h 60h 00h 00h 00h 00h 00h // read Profile Velocity setpoint
Wait 20

Wait 1000

JumpToHere:

Send 201h  2  5Fh 00h // RPDO1 Control Word bit 4 ON (start new move)
Wait 20

Send 201h  2  4Fh 00h // RPDO1 Control Word bit 4 OFF (reset bit 4)
Wait 10

Inposition:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 06h 00h 00h //wait for status word bit 10 (Target Reached)
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 16h 00h 00h
			if false
			//if true
				//goto Stop
			//Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 02h 00h 00h
				//if true
					//goto Stop
		goto Inposition
	
wait 1000

GoTo JumpToHere
Stop:
