// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program sets the AKD drive to Profile Position Mode, commands target positions,
//and executes relative moves with time delays between.
//Configure the AKD drive to run motion tasks in position mode. Save to eeprom. Then run this program.


//Set up PGEARI and PGEARO
//Send 601h  8  23h 93h 60h 01h 00h 00h 10h 00h // PGEARO = 20 bit
//Wait 20
//Send 601h 8 40h 93h 60h 01h 00h 00h 00h 00h // 
//Wait 20

//Send 601h  8  23h 93h 60h 02h 10h 27h 00h 00h // PGEARI = 10000 units
//Wait 20
//Send 601h 8 40h 93h 60h 02h 00h 00h 00h 00h // 
//Wait 20

// ready to switch on	
Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 07h 00h 00h 00h // Control Word: switched on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enable
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

//***** Home Mode *****
Send 601h  8  2fh 60h 60h 00h 06h 00h 00h 00h // switch to homing mode (DS402 Mode 06)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h // read opmode
Wait 20

Send 601h  8  2fh 98h 60h 00h 22h 00h 00h 00h // Home.Mode=7 (home to current position)
Wait 20
//Send 601h  8  2fh 98h 60h 00h 23h 00h 00h 00h // homing mode: set homing type - NREF=0
//Wait 20
Send 601h 8 40h 98h 60h 00h 00h 00h 00h 00h // read home type
Wait 20

Send 601h  8  2bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word: start homing (Bit 4)
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20
Send 601h  8 40h 02h 10h 00h 00h 00h 00h 00h // Obj 1002 status word
Wait 20

nothome:
Send 601h  8 40h 02h 10h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 43h 02h 10h 00h 0Ah 40h 80h 20h //wait for 1002 bit 23 (Homing move finished)
	if true
		goto homecomplete
		
Send 601h  8 40h 02h 10h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 43h 02h 10h 00h 02h 40h 80h 20h
	if false
		goto nothome
			//if true
				//goto Stop
			//Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 02h 00h 00h
				//if true
					//goto Stop
			
homecomplete:

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: stop homing (after finished)
Wait 2000

Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on (disable)
Wait 20


//**** Setup move ****

Send 601h  8  2Fh 60h 60h 00h 01h 00h 00h 00h // switch to profile position mode (DS402 Mode 01)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 83h 60h 00h F0h 21h 00h 00h // acceleration command = 500
Wait 20
//Send 601h  8  23h 83h 60h 00h 32h 00h 00h 00h // acceleration command = 50
//Wait 20
Send 601h 8 40h 83h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 84h 60h 00h F0h 21h 00h 00h // deceleration command = 500
Wait 20
//Send 601h  8  23h 84h 60h 00h 32h 00h 00h 00h // deceleration command = 50
//Wait 20
Send 601h 8 40h 84h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 81h 60h 00h 20h 02h 00h 00h // Profile Velocity setpoint (velocity command for position move) 100 rpm
Wait 20
Send 601h 8 40h 81h 60h 00h 00h 00h 00h 00h
Wait 20

//Send 601h  8  23h 94h 60h 01h 00h 00h 10h 00h // Velocity encoder factor - numerator
//Wait 20
//Send 601h 8 40h 94h 60h 01h 00h 00h 00h 00h
//Wait 20

//Send 601h  8  23h 94h 60h 02h 01h 00h 00h 00h // Velocity encoder factor - denominator
//Wait 20
//Send 601h 8 40h 94h 60h 02h 00h 00h 00h 00h
//Wait 20

Send 601h  8  2Bh 86h 60h 00h 01h 00h 00h 00h // motion profile type - Linear (trapezoidal)
Wait 20
Send 601h 8 40h 86h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 7Ah 60h 00h 10h 27h 00h 00h // write target position
Wait 20
Send 601h  8  40h 7Ah 60h 00h 00h 00h 00h 00h // read target position
Wait 20

Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // disabled, 
Wait 20
Send 601h  8  2bh 40h 60h 00h 07h 00h 00h 00h // enabled, 
Wait 20
Send 601h  8  2bh 40h 60h 00h 0fh 00h 00h 00h // operation enabled, 
Wait 20
Send 601h  8  2bh 40h 60h 00h 6fh 00h 00h 00h // operation enabled, relative move (Bit 6 = 1)
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

JumpToHere:

Send 601h  8  2bh 40h 60h 00h 7Fh 00h 00h 00h // Control Word bit 4 ON (start new move)
Wait 20
Send 601h  8  2bh 40h 60h 00h 6Fh 00h 00h 00h // Control Word bit 4 OFF (reset bit 4)
Wait 20

//Send 201h  2  5Fh 00h // RPDO1 Control Word bit 4 ON (start new move)
//Wait 20

//Send 201h  2  4Fh 00h // RPDO1 Control Word bit 4 OFF (reset bit 4)
//Wait 10

Inposition:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 04h 00h 00h //wait for status word bit 10 (Target Reached)
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 14h 00h 00h
			if false
			//Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 02h 00h 00h
				//if true
					//goto Stop
			goto Inposition
	
wait 500

GoTo JumpToHere
Stop:
